
#include <stdio.h>
#include <unistd.h>

#include "COM.h"


#define ENQ	0x05
#define EOT	0x04


void main (int argc, char* argv[])
{
 FILE* file;
 int port;
 int n;
 char buffer[64];

 if (argc != 2)
   {
    printf("Uso: TRA nome-file\r\n");
    return;
   }

 file = fopen(argv[1],"rt");
 if (file == NULL)
   {
    printf("Fallimento apertura file\r\n");
    return;
   }

 if ((long)(port = COM_open(0, READ_WRITE, 9600, 'n', 8, 1, NO_HANDSHAKE)) < 0)
   {
    printf("Fallimento apertura porta seriale\r\n");
    return;
   }

 while (1) // ciclo di attesa carattere ENQ
      {
	     if (COM_read(port, buffer, 1) > 0)
	     if (buffer[0] == ENQ)
		     break;
      }
       
 while (!feof(file))
      {
	     n = fread(buffer, 1, sizeof(buffer), file);
       COM_write(port, buffer, n);
	     usleep(100000); //0.1s
      }

 buffer[0] = EOT;
 COM_write(port, buffer, 1);
 COM_close(port);
 fclose(file);
}
