
#include <stdio.h>
#include <unistd.h>

#include "COM.h"


#define STX	0x02
#define ETX	0x03
#define EOT	0x04


void main (int argc, char* argv[])
{
 FILE* file;
 int port;
 int n;
 char buffer[128];
 char stx[1] = {STX};
 char etx[1] = {ETX};
 char eot[1] = {EOT};

 if (argc != 2)
   {
    printf("Uso: TX nome-file\r\n");
    return;
   }

 file = fopen(argv[1],"rt");
 if (file == NULL)
   {
    printf("Fallimento apertura file\r\n");
    return;
   }

 if ((long)(port = COM_open(0, READ_WRITE, 9600, 'n', 8, 1, NO_HANDSHAKE)) < 0)
   {
    printf("Fallimento apertura porta seriale\r\n");
    return;
   }

 while (!feof(file))
      {
	   n = fread(buffer, 1, sizeof(buffer), file);
	   COM_write(port, stx, 1);
       COM_write(port, buffer, n);
	   COM_write(port, etx, 1);
	   usleep(100000); // 0.1s
      }

 COM_write(port, eot, 1);
 usleep(100000); // 0.1s
 COM_close(port);
 fclose(file);
}

